#pragma once

namespace a8
{
    class Args
    {
    public:

        Args(std::vector<std::any> args):args_(std::move(args)) {};

        template <typename T>
        T Get(size_t index) const { return std::any_cast<T>(args_.at(index));};

    private:
        std::vector<std::any> args_;
    };
}
