#pragma once

#include <a8/basehttpsession.h>

namespace a8
{
    class MixedSession: public BaseHttpSession
    {
    protected:
        virtual void Reset() override;
        virtual void Destory() override;
        virtual void DecodePacket(char* buf, int& offset, unsigned int buflen) override;

        void ProcessHandShake(char* buf, int& offset, unsigned int buflen);

    private:
        bool is_first_packet_ = true;

    };

}
