#pragma once

namespace a8
{

    class MutableXObject : public XObject
    {
    protected:
        MutableXObject();

    public:

        static std::shared_ptr<a8::MutableXObject> CreateObject();
        static std::shared_ptr<a8::MutableXObject> CreateArray();

        a8::MutableXObject& Push(a8::XValue val);
        a8::MutableXObject& Push(a8::XObject& val);
        a8::MutableXObject& SetVal(const std::string& key, a8::XValue val);
        a8::MutableXObject& SetVal(const std::string& key, a8::XObject& val);
        a8::MutableXObject& SetVal(const std::string& key, a8::MutableXObject& val);

    };

}
