#pragma once

#include <a8/singleton.h>

namespace a8
{

    class PerfMonitor : public a8::Singleton<PerfMonitor>
    {
    private:
        PerfMonitor();
        friend class a8::Singleton<PerfMonitor>;

    public:
        void Init();
        void UnInit();

    public:
        long long send_eagain_times = 0;
        long long recv_eagain_times = 0;
        long long max_send_time = 0;
        long long max_recv_time = 0;

    };

}
