#pragma once

namespace a8
{
    class TcpSession;
    class TcpSessionPool
    {
        struct TcpSessionNode;
    public:

        TcpSessionPool();
        ~TcpSessionPool();

        void Add(a8::TcpSession* session);
        a8::TcpSession* Get();
        int Count();

    private:
        void ClearTimeOutSocket();

    private:
        a8::TcpSessionPool::TcpSessionNode* top_node_ = nullptr;
        a8::TcpSessionPool::TcpSessionNode* bot_node_ = nullptr;
        int count_ = 0;
    };
}
