#pragma once

namespace std
{
    class thread;
    class mutex;
    class condition_variable;
};

namespace google
{
    namespace protobuf
    {
        class Message;
    }
}

namespace a8
{
    typedef long long tick_t;
    struct XTimerPtr;

    struct SendQueueNode
    {
        char* buff;
        unsigned int bufflen;
        unsigned int sent_bytes;
        SendQueueNode* next;
    };

    typedef std::function<void(const a8::Args&)> CommonCbProc;
    typedef std::function<void(const a8::Args*)> CommonCbProcEx;
    typedef std::weak_ptr<struct XTimerPtr> XTimerWp;

    const int INVALID_FD = -1;
    const int INVALID_SOCKET = -1;
    const int INVALID_SOCKET_HANDLE = 0;

    const int TIMER_EXEC_EVENT = 1;
    const int TIMER_DELETE_EVENT = 2;
    const int TIMER_DESTORY_EVENT = 3;
    const int TIMER_USER_EVENT = 66;

    namespace reflect
    {
        class Class;
    }
};

template<typename T>
const char* GetEnumString()
{
    return nullptr;
};
